## ocamlduce 3.11.1.0

=== Makefile ===
#-include config/Makefile

OCAML_VERSION := $(shell ocamlc -version)
OCAML_SOURCE := /usr/src/ocaml-source-$(OCAML_VERSION).tar.bz2
OCAML_SRCDIR := ocaml-$(OCAML_VERSION)

DUCE_VERSION := $(shell head -n1 VERSION)
DUCE_SRCDIR := ocamlduce-$(DUCE_VERSION)

DUCE_LIBDIR := $(LIBDIR)/ocamlduce

BASE_BYT := ocamlc ocamldoc/ocamldoc tools/ocamldep
BYT := ocaml $(BASE_BYT)
OPT := ocamlopt ocamlopt.opt $(addsuffix .opt,$(BASE_BYT))

MLI := toplevel/toploop.mli toplevel/topdirs.mli \
  toplevel/topmain.mli otherlibs/ocamlduce/ocamlduce.mli

CMI := $(MLI:.mli=.cmi) otherlibs/ocamlduce/cduce_types.cmi

CMA := otherlibs/ocamlduce/ocamlduce.cma
CMXA := $(CMA:.cma=.cmxa) $(CMA:.cma=.a)

TOPCMO := toplevel/toploop.cmo toplevel/topdirs.cmo \
  toplevel/topmain.cmo toplevel/topstart.cmo \

TOPCMA := toplevel/toplevellib.cma

DIR_PATCHES := parsing typing utils bytecomp asmcomp driver toplevel ocamldoc tools
BUILD_PATCH := myocamlbuild.ml myocamlbuild_config.mli _tags

DUCED_FILES := LICENSE README Makefile Changes
DUCEP_FILES := META.in VERSION ocamlducefind mkocamlduce.sh

all:
	@echo "===> Please explicit what you want <==="

prepare:
	tar xf $(OCAML_SOURCE)
	cp -PpR $(DUCEP_FILES) $(OCAML_SRCDIR)
	cp -PpR ocamlduce $(OCAML_SRCDIR)/otherlibs
	cd $(OCAML_SRCDIR) && for X in ../patches/*.diff; do patch -p1 < $$X; done
	for X in $(DUCED_FILES); do cp $$X $(OCAML_SRCDIR)/$$X.ocamlduce; done
	sed '\@^#-include config/Makefile@s/^#//' $(OCAML_SRCDIR)/Makefile.ocamlduce > $(OCAML_SRCDIR)/Makefile.ocamlduce.new
	mv $(OCAML_SRCDIR)/Makefile.ocamlduce.new $(OCAML_SRCDIR)/Makefile.ocamlduce

config/Makefile:
	@echo "===> You should probably run ./configure yourself, trying on my own... <==="
	$(shell sed -ne '1s@^.*\(./configure.*\)$$@\1@p' $(shell ocamlc -where)/Makefile.config)

world: config/Makefile
	MAKE="$(MAKE)" CFLAGS="$(CFLAGS)" ./mkocamlduce.sh

world.opt: config/Makefile
	MAKE="$(MAKE)" CFLAGS="$(CFLAGS)" HAS_NATIVE=y ./mkocamlduce.sh

META: META.in
	sed 's/%VER%/$(DUCE_VERSION)/' $< > $@

installcommon-stamp: META
	@echo "===> Installing common files... <==="
	install -m 755 -d $(BINDIR)
	install -m 755 -d $(DUCE_LIBDIR)
	install -m 755 ocamlducefind $(BINDIR)
	install -m 644 META $(DUCE_LIBDIR)
	install -m 644 $(addprefix _build/,$(MLI)) $(DUCE_LIBDIR)
	install -m 644 $(addprefix _build/,$(CMI)) $(DUCE_LIBDIR)

installbyte: installcommon-stamp
	@echo "===> Installing non-native files... <==="
	for X in $(BYT); do Y=$${X##*/}; Y=$${Y#ocaml}; install -m 755 _build/$$X $(BINDIR)/ocamlduce$$Y; done
	install -m 644 $(addprefix _build/,$(TOPCMO)) $(DUCE_LIBDIR)
	install -m 644 $(addprefix _build/,$(TOPCMA)) $(DUCE_LIBDIR)
	install -m 644 $(addprefix _build/,$(CMA)) $(DUCE_LIBDIR)

installopt: installcommon-stamp
	@echo "===> Installing native files... <==="
	for X in $(OPT); do Y=$${X##*/}; Y=$${Y#ocaml}; install -m 755 _build/$$X $(BINDIR)/ocamlduce$$Y; done
	install -m 644 $(addprefix _build/,$(CMXA)) $(DUCE_LIBDIR)

clean:
	build/distclean.sh
	rm -f META

dist:
	git clean -dxf
	touch config/Makefile
	mkdir -p $(DUCE_SRCDIR)/patches
	for X in $(DIR_PATCHES); do git diff upstream -- $$X > $(DUCE_SRCDIR)/patches/$$X.diff; done
	git diff upstream -- $(BUILD_PATCH) > $(DUCE_SRCDIR)/patches/build.diff
	for X in $(DUCED_FILES); do cp -a $$X.ocamlduce $(DUCE_SRCDIR)/$$X; done
	cp -t $(DUCE_SRCDIR) -a otherlibs/ocamlduce
	cp -t $(DUCE_SRCDIR) -a $(DUCEP_FILES)
	sed -i '\@^-include config/Makefile@s/^/#/' $(DUCE_SRCDIR)/Makefile
	tar czf $(DUCE_SRCDIR).tar.gz $(DUCE_SRCDIR)


.PHONY: all installbyte installopt clean dist prepare world world.opt

## ocamlduce 3.11.2.0

=== debian/changelog ===
ocamlduce (3.11.2.0-1) unstable; urgency=low

  * New upstream release
    - remove all patches that have been merged upstream
  * Bump Standards-Version to 3.8.4 (no changes)

 -- Stéphane Glondu <glondu@debian.org>  Tue, 09 Feb 2010 09:07:47 +0100

ocamlduce (3.11.1.0-3) unstable; urgency=low

  * Switch to 3.0 (quilt)
  * Add Replaces/Conflicts to previous versions of ocamlduce in
    ocamlduce-base (Closes: #553177)

 -- Stéphane Glondu <glondu@debian.org>  Thu, 05 Nov 2009 00:18:48 +0100

ocamlduce (3.11.1.0-2) unstable; urgency=low

  * Switch packaging to dh-ocaml 0.9:
    - build and install ocamlduceobjinfo
      + add patches-ocaml/objinfo.patch
  * Put runtime files into (new) binary ocamlduce-base
  * Ship ocamlducedoc library files
  * Use /usr/share/misc/config.{sub,guess} when available to fix FTBFS
    on avr32 (Closes: #538166)
  * debian/control:
    - update my e-mail address and remove DMUA
    - update Standards-Version to 3.8.3 (no changes)
  * Update watch file

 -- Stéphane Glondu <glondu@debian.org>  Fri, 16 Oct 2009 10:55:12 +0200

ocamlduce (3.11.1.0-1) unstable; urgency=low

  * New upstream release, merged with OCaml 3.11.1
  * Update Standards-Version to 3.8.2
  * Move to section ocaml
  * Build and install native plugin:
    - add dependency to quilt
    - add Build-and-install-native-code-plugin.patch
  * Add README.source

 -- Stephane Glondu <steph@glondu.net>  Wed, 24 Jun 2009 17:22:11 +0200

ocamlduce (3.11.0.0~rc1-2) unstable; urgency=low

  * First upload to unstable
  * Use ocamlinit from dh-ocaml

 -- Stephane Glondu <steph@glondu.net>  Sat, 07 Mar 2009 19:27:31 +0100

ocamlduce (3.11.0.0~rc1-1) experimental; urgency=low

  * Initial release (Closes: #469460)

 -- Stephane Glondu <steph@glondu.net>  Tue, 20 Jan 2009 10:18:01 +0100

=== debian/control ===
Source: ocamlduce
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Stéphane Glondu <glondu@debian.org>
Build-Depends:
 debhelper (>= 7.2.11~),
 dh-ocaml (>= 0.9.1~),
 autotools-dev,
 patch,
 ocaml-source (>= 3.11.2),
 ocaml-nox (>= 3.11.2)
Standards-Version: 3.8.4
Homepage: http://ocamlduce.forge.ocamlcore.org/
Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/ocamlduce.git
Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/ocamlduce.git

Package: ocamlduce
Architecture: any
Depends:
 ocaml-interp,
 ocaml-findlib,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Description: OCaml extended with XML types
 OCamlDuce is a merger between OCaml and CDuce. It comes as a modified
 version of OCaml which integrates CDuce features: XML expressions,
 regular expression types and patterns, iterators. In particular, it
 extends OCaml with a new kind of values to represent XML documents,
 fragments, tags and Unicode strings.
 .
 OCamlDuce is binary compatible with OCaml: OCaml modules can be used
 with OCamlDuce, and OCamlDuce modules can be used with OCaml ones,
 provided they don't export a feature specifically introduced in
 OCamlDuce.
 .
 This package provides modified versions of the OCaml tools (toplevel,
 native and bytecode compilers, ocamldoc, ocamldep, ocamlfind).

Package: ocamlduce-base
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Replaces: ocamlduce (<< 3.11.1.0-2~)
Conflicts: ocamlduce (<< 3.11.1.0-2~)
Description: OCaml extended with XML types (runtime)
 OCamlDuce is a merger between OCaml and CDuce. It comes as a modified
 version of OCaml which integrates CDuce features: XML expressions,
 regular expression types and patterns, iterators. In particular, it
 extends OCaml with a new kind of values to represent XML documents,
 fragments, tags and Unicode strings.
 .
 This package provides runtime libraries of OCamlDuce.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for ocamlduce

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/ocaml/ocamlvars.mk

# We do as in ocaml: the ABI is the upstream version number and we
# need to use a special ocamlobjinfo for OCamlDuce compiled interfaces
export OCAMLOBJINFO := debian/tmp/usr/bin/ocamlduceobjinfo
OCAMLDUCE_ABI := $(shell head -n1 debian/changelog|awk -F'[()-]' '{print $$2}'|sed 's/~/+/g')

BUILD_TARGET := $(if $(OCAML_OPT_ARCH),world.opt,world)
INSTALL_TARGET := installbyte $(if $(OCAML_OPT_ARCH),installopt)

OCAML_SRCDIR := ocaml-$(OCAML_ABI)
MAKE_DUCE := $(MAKE) -C $(OCAML_SRCDIR) -f Makefile.ocamlduce
ODOC_DESTDIR := debian/tmp$(OCAML_STDLIB_DIR)/ocamlduce/ocamldoc

%:
	dh --with ocaml $@

.PHONY: override_dh_auto_configure
override_dh_auto_configure:
	$(MAKE) prepare
	for ext in sub guess; do \
	  if [ -f /usr/share/misc/config.$$ext ]; then \
	    cp -f /usr/share/misc/config.$$ext $(OCAML_SRCDIR)/config/gnu/config.$$ext; \
	  fi; \
	done
	cd $(OCAML_SRCDIR) && \
	  ./configure -prefix /usr -libdir $(OCAML_STDLIB_DIR)
	sed -i \
	  -e "s%LIBDIR=.*$$%LIBDIR=\$$(PREFIX)$(patsubst /usr/%,/%,$(OCAML_STDLIB_DIR))%g" \
	  $(OCAML_SRCDIR)/config/Makefile

.PHONY: override_dh_auto_build
override_dh_auto_build:
	$(MAKE_DUCE) $(BUILD_TARGET)
	cd $(OCAML_SRCDIR) && ocamlbuild -lflags -I,otherlibs/ocamlduce tools/objinfo.byte

.PHONY: override_dh_auto_install
override_dh_auto_install:
	$(MAKE_DUCE) PREFIX=../debian/tmp/usr $(INSTALL_TARGET)
	install -m 755 $(OCAML_SRCDIR)/_build/tools/objinfo.byte \
	  debian/tmp/usr/bin/ocamlduceobjinfo
	mkdir -p $(ODOC_DESTDIR)
	find $(OCAML_STDLIB_DIR)/ocamldoc -type f -printf \
	  '$(OCAML_SRCDIR)/_build/ocamldoc/%P\0' \
	  | xargs -0 cp -t $(ODOC_DESTDIR)

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	rm -Rf $(OCAML_SRCDIR)

.PHONY: override_dh_ocaml
override_dh_ocaml:
	dh_ocaml --checksum=$(OCAMLDUCE_ABI) \
	  --runtime-map=ocamlduce:ocamlduce-base \
	  -Xtoplevellib.cma -Xocamldoc \
	  --nodefined-map=ocamlduce:Topdirs,Toploop,Topmain,Topstart

=== debian/watch ===
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

opts="uversionmangle=s/rc/~rc/" \
http://forge.ocamlcore.org/frs/?group_id=75 /frs/download.php/.*/ocamlduce-(.*)\.tar\.gz

## ocamlduce 3.12.0.0

=== Makefile ===
--- 
+++ 
@@ -20,6 +20,7 @@
 
 CMA := otherlibs/ocamlduce/ocamlduce.cma
 CMXA := $(CMA:.cma=.cmxa) $(CMA:.cma=.a)
+CMXS := $(CMA:.cma=.cmxs)
 
 TOPCMO := toplevel/toploop.cmo toplevel/topdirs.cmo \
   toplevel/topmain.cmo toplevel/topstart.cmo \
@@ -76,7 +77,7 @@
 installopt: installcommon-stamp
 	@echo "===> Installing native files... <==="
 	for X in $(OPT); do Y=$${X##*/}; Y=$${Y#ocaml}; install -m 755 _build/$$X $(BINDIR)/ocamlduce$$Y; done
-	install -m 644 $(addprefix _build/,$(CMXA)) $(DUCE_LIBDIR)
+	install -m 644 $(addprefix _build/,$(CMXA) $(CMXS)) $(DUCE_LIBDIR)
 
 clean:
 	build/distclean.sh
@@ -96,3 +97,39 @@
 
 
 .PHONY: all installbyte installopt clean dist prepare world world.opt
+
+SRC = \
+ misc/custom.ml \
+ misc/encodings.ml \
+ misc/imap.ml \
+ misc/state.ml \
+ misc/upool.ml \
+ misc/ns.ml \
+ types/sortedList.ml \
+ types/atoms.ml \
+ misc/bool.ml \
+ types/chars.ml \
+ types/ident.ml \
+ types/intervals.ml \
+ misc/inttbl.ml \
+ types/normal.ml \
+ misc/pretty.ml \
+ misc/stats.ml \
+ types/compunit.ml \
+ types/types.ml \
+ types/sequence.ml \
+ types/sample.ml \
+ compile/auto_pat.ml \
+ types/patterns.ml \
+ runtime/value.ml \
+ runtime/run_dispatch.ml \
+ runtime/explain.ml \
+ typing/typepat.ml \
+ runtime/serial.ml
+
+.PHONY: update-cduce
+update-cduce:
+	cd otherlibs/ocamlduce && \
+	for i in $(SRC) $(SRC:.ml=.mli); do \
+	  if test -f $(CDUCE_DIR)/$$i; then cp --remove-destination $(CDUCE_DIR)/$$i .; else :; fi \
+	done

=== debian/changelog ===
ocamlduce (3.12.0.0-1build1) oneiric; urgency=low

  * Rebuild to pick up armel ocaml fixes.

 -- Adam Conrad <adconrad@ubuntu.com>  Fri, 19 Aug 2011 13:33:39 -0600

ocamlduce (3.12.0.0-1) unstable; urgency=low

  * New upstream release:
    - compatible with OCaml 3.12.0 (Closes: #580102)
    - compatible with recent binutils (Closes: #618089)
  * Fix debian/watch
  * Install native plugin only on natdynlink architectures
  * Bump debhelper compat level to 8
  * Bump Standards-Version to 3.9.2

 -- Stéphane Glondu <glondu@debian.org>  Sun, 17 Apr 2011 11:37:54 +0200

=== debian/control ===
--- 
+++ 
@@ -4,13 +4,13 @@
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Stéphane Glondu <glondu@debian.org>
 Build-Depends:
- debhelper (>= 7.2.11~),
- dh-ocaml (>= 0.9.1~),
+ debhelper (>= 8),
+ dh-ocaml (>= 1.0.0~),
  autotools-dev,
  patch,
- ocaml-source (>= 3.11.2),
- ocaml-nox (>= 3.11.2)
-Standards-Version: 3.8.4
+ ocaml-source (>= 3.12.0),
+ ocaml-nox (>= 3.12.0)
+Standards-Version: 3.9.2
 Homepage: http://ocamlduce.forge.ocamlcore.org/
 Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/ocamlduce.git
 Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/ocamlduce.git
@@ -47,7 +47,7 @@
  ${misc:Depends}
 Provides: ${ocaml:Provides}
 Replaces: ocamlduce (<< 3.11.1.0-2~)
-Conflicts: ocamlduce (<< 3.11.1.0-2~)
+Breaks: ocamlduce (<< 3.11.1.0-2~)
 Description: OCaml extended with XML types (runtime)
  OCamlDuce is a merger between OCaml and CDuce. It comes as a modified
  version of OCaml which integrates CDuce features: XML expressions,

## ocamlduce 3.12.1.0

=== debian/changelog ===
ocamlduce (3.12.1.0-1) unstable; urgency=low

  * New upstream release, compatible with OCaml 3.12.1

 -- Stéphane Glondu <glondu@debian.org>  Tue, 01 Nov 2011 20:49:37 +0100

=== debian/control ===
--- 
+++ 
@@ -8,8 +8,8 @@
  dh-ocaml (>= 1.0.0~),
  autotools-dev,
  patch,
- ocaml-source (>= 3.12.0),
- ocaml-nox (>= 3.12.0)
+ ocaml-source (>= 3.12.1),
+ ocaml-nox (>= 3.12.1)
 Standards-Version: 3.9.2
 Homepage: http://ocamlduce.forge.ocamlcore.org/
 Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/ocamlduce.git

=== debian/watch ===
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

opts="uversionmangle=s/rc/~rc/" \
http://forge.ocamlcore.org/frs/?group_id=75 .*/ocamlduce-(.*)\.tar\.gz
